SystemOrganization addCategory: #'Pier-Debugging'!

!PRContentsWidget methodsFor: '*pier-debugging-override' stamp: 'kph 8/15/2007 11:43'!
onAnswerCommand: aCommand
	aCommand isNil
		ifTrue: [ ^ self context: (self context structure: self context structure) ].
	[ aCommand execute ]
		on: Error
		do: [ :err | 
			 
			Preferences debugPierFormErrors ifTrue: [ err pass ].
			
			^ self component errors add: err.  ].
	self context: aCommand answer! !

!Object methodsFor: '*pier-debugging' stamp: 'kph 8/17/2007 07:36'!
helpfulError: msg

	Preferences helpfulErrors ifTrue: [ self error: msg ].! !

Object subclass: #PRDebugging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Debugging'!

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 8/17/2007 07:39'!
initialize
 
	Preferences addBooleanPreference: #helpfulErrors categories: #( seaside ) default: false balloonHelp: 'Enable helpful errors. (See senders of #helpfulError:)'.
		
	Preferences addBooleanPreference: #haltOnForbidden categories: #( seaside ) default: false balloonHelp: 'Halt when user accesses a forbidden page'.
	
	Preferences addBooleanPreference: #haltOnDbCommit categories: #( seaside ) default: false balloonHelp: 'Halt when write is made to database (if you have one)'. 
	
	Preferences addBooleanPreference: #debugInvalidLogin categories: #( seaside ) default: false balloonHelp: 'Halt when pier login is invalid'.
	
	Preferences addBooleanPreference: #debugPierFormErrors categories: #( seaside ) default: false balloonHelp: 'Halt when pier form validaton error occurs'.
	
	Preferences addBooleanPreference: #dbLogEveryRowReturned categories: #( seaside ) default: false balloonHelp: 'Log everything returned from a db query'.

! !

!PULogin methodsFor: '*pier-debugging-override' stamp: 'kph 8/16/2007 15:56'!
invalidLogin

	Preferences haltOnInvalidLogin ifTrue: [ self halt ].

	PUInvalidLogin
		description: self description
		signal: 'Invalid username or password.'! !

!WAComponent methodsFor: '*pier-debugging-override' stamp: 'kph 8/17/2007 06:59'!
decoration
	decoration ifNil: [ self error: 'I bet you didnt put super initialize in that new component did you?' ].
	^ decoration contents! !

!PRPierMain methodsFor: '*pier-debugging-override' stamp: 'kph 8/16/2007 15:48'!
forbidden: aRequest

	Preferences haltOnForbidden  ifTrue: [ self halt ].

	self return: (WAResponse forbidden: aRequest url)! !
PRDebugging initialize!
